Attribute VB_Name = "modRegistry"
Option Explicit
Private Const MyName As String = "Registry"


'    .
'(c) GSerg, 2004


Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" ( _
                  ByVal hKey As Long, _
                  ByVal lpSubKey As String, _
                  ByVal Reserved As Long, _
                  ByVal lpClass As String, _
                  ByVal dwOptions As RegCreateAs, _
                  ByVal samDesired As RegRights, _
                  lpSecurityAttributes As Any, _
                  phkResult As Long, _
                  lpdwDisposition As Long) As Long

Private Declare Function SHDeleteKey Lib "shlwapi.dll" Alias "SHDeleteKeyA" (ByVal hKey As Long, ByVal pszSubKey As String) As Long

Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As RegRights, phkResult As Long) As Long

'Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Any, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, ByRef lpcbClass As Long, ByRef lpReserved As Long, ByRef lpcSubKeys As Long, ByRef lpcbMaxSubKeyLen As Long, ByRef lpcbMaxClassLen As Long, ByRef lpcValues As Long, ByRef lpcbMaxValueNameLen As Long, ByRef lpcbMaxValueLen As Long, ByRef lpcbSecurityDescriptor As Long, lpftLastWriteTime As Any) As Long

Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long

Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" (ByVal lpSrc As String, ByVal lpDst As String, ByVal nSize As Long) As Long

Public Enum RegRoots
  HKEY_CLASSES_ROOT = &H80000000
  HKEY_CURRENT_USER = &H80000001
  HKEY_LOCAL_MACHINE = &H80000002
  HKEY_USERS = &H80000003
  HKEY_PERFORMANCE_DATA = &H80000004
  HKEY_CURRENT_CONFIG = &H80000005
  HKEY_DYN_DATA = &H80000006
End Enum

Public Enum RegDataTypes
  REG_NONE = 0                      ' No value type
  REG_SZ = 1                        ' Unicode nul terminated string
  REG_EXPAND_SZ = 2                 ' Unicode nul terminated string with templates
  REG_BINARY = 3                    ' Free form binary
  REG_DWORD = 4                     ' 32-bit number
  REG_DWORD_LITTLE_ENDIAN = 4       ' 32-bit number (same as REG_DWORD)
  REG_DWORD_BIG_ENDIAN = 5          ' 32-bit number (hi and low swapped)
  REG_LINK = 6                      ' Symbolic Link (unicode)
  REG_MULTI_SZ = 7                  ' Multiple Unicode strings
  REG_RESOURCE_LIST = 8             ' Resource list in the resource map
  REG_FULL_RESOURCE_DESCRIPTOR = 9  ' Resource list in the hardware description
  REG_RESOURCE_REQUIREMENTS_LIST = 10
  REG_QWORD = 11
End Enum

Private Enum WhatCreateExDid
  REG_CREATED_NEW_KEY = &H1&          ' New Registry Key created
  REG_OPENED_EXISTING_KEY = &H2&      ' Existing Key opened
End Enum

Public Enum Reg1
  REG_WHOLE_HIVE_VOLATILE = &H1&      ' Restore whole hive volatile
  REG_REFRESH_HIVE = &H2&             ' Unwind changes to last flush
End Enum

Public Enum RegNotify
  REG_NOTIFY_CHANGE_NAME = &H1&       ' Create or delete (child)
  REG_NOTIFY_CHANGE_ATTRIBUTES = &H2&
  REG_NOTIFY_CHANGE_LAST_SET = &H4&   ' Time stamp
  REG_NOTIFY_CHANGE_SECURITY = &H8&
End Enum

Public Enum RegRights
  Delete = &H10000        '   -  Delete  OLE
  READ_CONTROL = &H20000
  SYNCHRONIZE = &H100000
  WRITE_DAC = &H40000
  WRITE_OWNER = &H80000
  
  STANDARD_RIGHTS_ALL = Delete Or READ_CONTROL Or WRITE_DAC Or WRITE_OWNER Or SYNCHRONIZE
  STANDARD_RIGHTS_EXECUTE = READ_CONTROL
  STANDARD_RIGHTS_READ = READ_CONTROL
  STANDARD_RIGHTS_REQUIRED = Delete Or READ_CONTROL Or WRITE_DAC Or WRITE_OWNER
  STANDARD_RIGHTS_WRITE = READ_CONTROL
  
  KEY_QUERY_VALUE = &H1&
  KEY_SET_VALUE = &H2&
  KEY_CREATE_SUB_KEY = &H4&
  KEY_ENUMERATE_SUB_KEYS = &H8&
  KEY_NOTIFY = &H10&
  KEY_CREATE_LINK = &H20&
  KEY_READ = (STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE)
  KEY_WRITE = (STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE)
  KEY_ALL_ACCESS = (STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE)
  KEY_EXECUTE = KEY_READ And (Not SYNCHRONIZE)
End Enum

Public Enum RegCreateAs
  'REG_OPTION_RESERVED = 0           ' Parameter is reserved
  REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted
  REG_OPTION_VOLATILE = 1           ' Key is not preserved when system is rebooted
  'REG_OPTION_CREATE_LINK = 2        ' Created key is a symbolic link
  REG_OPTION_BACKUP_RESTORE = 4     ' open for backup or restore
  'REG_LEGAL_CHANGE_FILTER = REG_NOTIFY_CHANGE_NAME Or REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or REG_NOTIFY_CHANGE_SECURITY
  'REG_LEGAL_OPTION = REG_OPTION_RESERVED Or REG_OPTION_NON_VOLATILE Or REG_OPTION_VOLATILE Or REG_OPTION_CREATE_LINK Or REG_OPTION_BACKUP_RESTORE
End Enum

Private Const ERROR_SUCCESS As Long = 0
Private Const ERROR_NO_MORE_ITEMS As Long = 259
Private Const ERROR_FILE_NOT_FOUND As Long = 2
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
'Private Const REG_FORCE_RESTORE As Long = 8

Private Enum RegFileLineTypes
  '     LineType
  lineInvalid = REG_NONE
  lineString = REG_SZ
  lineDWord = REG_DWORD
  lineHex = REG_BINARY
  lineMultiString = REG_MULTI_SZ
  lineExpandedString = REG_EXPAND_SZ
  lineQWord = REG_QWORD
  lineKey = &H80000000
End Enum

Public Type RegValueDescr
  Name As String
  ValueType As RegDataTypes
  Value As Variant
End Type

Private fileHandle As Integer '      

Property Get Value(ByVal Root As RegRoots, RegPath As String, ValueName As String, ByRef ValueType As RegDataTypes) As Variant
  ' ValueType   .
  Dim keyHandle As Long, ret As Long
  Dim strBuf As String, dwdBuf As Long, qwdBuf As Currency, binBuf() As Byte
  Dim ReqBufSize As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_QUERY_VALUE, keyHandle)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  
  '    
  ret = RegQueryValueEx(keyHandle, ValueName, 0, ValueType, ByVal 0&, ReqBufSize)
  If ret <> ERROR_SUCCESS Then
    RegCloseKey keyHandle
    ErrRaise ret
  End If
  
  Select Case ValueType
  Case REG_SZ
    strBuf = Space$(ReqBufSize)
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, ByVal strBuf, ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = Left$(strBuf, ReqBufSize - 1)
  Case REG_MULTI_SZ
    strBuf = Space$(ReqBufSize)
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, ByVal strBuf, ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = Split(Left$(strBuf, ReqBufSize - 2), vbNullChar)
  Case REG_EXPAND_SZ
    strBuf = Space$(ReqBufSize)
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, ByVal strBuf, ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = ExpandString(Left$(strBuf, ReqBufSize - 1))
  Case REG_DWORD
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, dwdBuf, ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = dwdBuf
  Case REG_BINARY
    ReDim binBuf(1 To ReqBufSize)
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, binBuf(1), ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = binBuf
  Case REG_QWORD
    ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, qwdBuf, ReqBufSize)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    Value = qwdBuf * 10000@
  Case Else
    RegCloseKey keyHandle
    Err.Raise 5, MyName, "Unsupported key type"
  End Select
  
  RegCloseKey keyHandle
End Property

Property Let Value(ByVal Root As RegRoots, RegPath As String, ValueName As String, ByRef ValueType As RegDataTypes, ByVal V As Variant)
  Dim keyHandle As Long, ret As Long, WhatWeDid As WhatCreateExDid
  Dim strBuf As String, qwdBuf As Currency
  Dim arrL() As Long, arrI() As Integer, arrB() As Byte
  Dim ArrPtr As Long, arrSize As Long
  
  If ValueType = REG_NONE Then ValueType = REG_SZ
  
  ' ...
  '  , ...
  '  Variant...
  Select Case ValueType
  Case REG_DWORD
    Select Case VarType(V)
    Case vbByte, vbInteger, vbLong
    Case Else
      Err.Raise 5, MyName, "Real Value type does not match specified ValueType"
    End Select
  Case REG_QWORD
    Select Case VarType(V)
    Case vbByte, vbInteger, vbLong, vbCurrency
    Case Else
      Err.Raise 5, MyName, "Real Value type does not match specified ValueType"
    End Select
  Case REG_SZ, REG_EXPAND_SZ
    If VarType(V) <> vbString Then Err.Raise 5, MyName, "Real Value type does not match specified ValueType"
  Case REG_MULTI_SZ
    Select Case VarType(V)
    Case vbString, vbString Or vbArray
    Case Else
      Err.Raise 5, MyName, "Real Value type does not match specified ValueType"
    End Select
  Case REG_BINARY
    Select Case VarType(V)
    Case vbArray Or vbByte, vbArray Or vbInteger, vbArray Or vbLong
    Case Else
      Err.Raise 5, MyName, "Real Value type does not match specified ValueType"
    End Select
  Case Else
    Err.Raise 5, MyName, "Unsupported key type"
  End Select
  
  ' , .  , .
  ret = RegCreateKeyEx(Root, RegPath, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, ByVal 0&, keyHandle, WhatWeDid)
  If ret <> ERROR_SUCCESS Then
    RegCloseKey keyHandle
    ErrRaise ret
  End If
  
  Select Case ValueType
  Case REG_DWORD
    ret = RegSetValueEx(keyHandle, ValueName, 0, ValueType, CLng(V), 4)
  Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
    If VarType(V) And vbArray Then
      strBuf = Join(V, vbNullChar) & vbNullChar & vbNullChar
      ret = RegSetValueEx(keyHandle, ValueName, 0, ValueType, ByVal strBuf, Len(strBuf))
    Else
      ret = RegSetValueEx(keyHandle, ValueName, 0, ValueType, ByVal CStr(V), Len(CStr(V)))
    End If
  Case REG_BINARY
    '׸        Variant...
    '   VarPtr,    ...
    ' .
    Select Case VarType(V)
    Case vbArray Or vbByte
      arrB = V
      ArrPtr = VarPtr(arrB(LBound(arrB)))
      arrSize = UBound(arrB) - LBound(arrB) + 1
    Case vbArray Or vbInteger
      arrI = V
      ArrPtr = VarPtr(arrI(LBound(arrI)))
      arrSize = (UBound(arrI) - LBound(arrI) + 1) * 2
    Case vbArray Or vbLong
      arrL = V
      ArrPtr = VarPtr(arrL(LBound(arrL)))
      arrSize = (UBound(arrL) - LBound(arrL) + 1) * 4
    End Select
    ret = RegSetValueEx(keyHandle, ValueName, 0, ValueType, ByVal ArrPtr, arrSize)
  Case REG_QWORD
    ret = RegSetValueEx(keyHandle, ValueName, 0, ValueType, CCur(V / 10000@), 8)
  End Select
  
  RegCloseKey keyHandle
  If ret <> ERROR_SUCCESS Then ErrRaise ret
End Property

Public Function Exists(ByVal Root As RegRoots, RegPath As String, Optional ValueName As String = vbNullString) As Boolean
  '   ,   
  '  ,    
  Dim ret As Long, keyHandle As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_QUERY_VALUE, keyHandle)
  Select Case ret
  Case ERROR_SUCCESS
    If Len(ValueName) = 0 Then
      Exists = True
      RegCloseKey keyHandle
    Else
      ret = RegQueryValueEx(keyHandle, ValueName, 0, ByVal 0&, ByVal 0&, ByVal 0&)
      RegCloseKey keyHandle
      Select Case ret
      Case ERROR_SUCCESS
        Exists = True
      Case ERROR_FILE_NOT_FOUND
        Exists = False
      Case Else
        ErrRaise ret
      End Select
    End If
  Case ERROR_FILE_NOT_FOUND
    Exists = False
  Case Else
    ErrRaise ret
  End Select
End Function

Public Function DeleteKey(ByVal Root As RegRoots, RegPath As String) As Boolean
  ' SHDeleteKey,     . 
  '    .
  Dim ret As Long
  
  ret = SHDeleteKey(Root, RegPath)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  DeleteKey = True
End Function

Public Function DeleteValue(ByVal Root As RegRoots, RegPath As String, ValueName As String) As Boolean
  Dim ret As Long, keyHandle As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_SET_VALUE, keyHandle)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  
  ret = RegDeleteValue(keyHandle, ValueName)
  RegCloseKey keyHandle
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  DeleteValue = True
End Function

Public Function SubKeys(ByVal Root As RegRoots, RegPath As String) As String()
  Dim outArr() As String
  Dim ret As Long, keyHandle As Long, keyNum As Long
  Dim keyNameLength As Long, MaxKeyName As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_ENUMERATE_SUB_KEYS Or KEY_QUERY_VALUE, keyHandle)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  
  ret = RegQueryInfoKey(keyHandle, vbNullString, 0, ByVal 0&, keyNum, MaxKeyName, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
  If ret <> ERROR_SUCCESS Then
    RegCloseKey keyHandle
    ErrRaise ret
  End If
  
  keyNum = keyNum - 1
  
  If keyNum < 0 Then
    RegCloseKey keyHandle
    Exit Function
  End If
  
  ReDim outArr(0 To keyNum)
  For keyNum = keyNum To 0 Step -1
    keyNameLength = MaxKeyName + 1
    outArr(keyNum) = Space$(keyNameLength)
    ret = RegEnumKeyEx(keyHandle, keyNum, outArr(keyNum), keyNameLength, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    outArr(keyNum) = Left$(outArr(keyNum), keyNameLength)
  Next
  
  RegCloseKey keyHandle
  SubKeys = outArr
End Function

Public Function SubValues(ByVal Root As RegRoots, RegPath As String) As RegValueDescr()
  Dim outArr() As RegValueDescr
  Dim ret As Long, keyHandle As Long, ValueNum As Long
  Dim strBuf As String, dwdBuf As Long, qwdBuf As Currency, binBuf() As Byte
  Dim valueNumLength As Long, MaxValueName As Long
  Dim keyDataLength As Long
    
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_QUERY_VALUE, keyHandle)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  
  ret = RegQueryInfoKey(keyHandle, vbNullString, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ValueNum, MaxValueName, ByVal 0&, ByVal 0&, ByVal 0&)
  If ret <> ERROR_SUCCESS Then
    RegCloseKey keyHandle
    ErrRaise ret
  End If
  
  ValueNum = ValueNum - 1
  
  If ValueNum < 0 Then
    RegCloseKey keyHandle
    Exit Function
  End If
  
  ReDim outArr(0 To ValueNum)
  For ValueNum = ValueNum To 0 Step -1
    valueNumLength = MaxValueName + 1
    outArr(ValueNum).Name = Space$(valueNumLength)
    
    '  ,    
    ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0, outArr(ValueNum).ValueType, ByVal 0&, keyDataLength)
    If ret <> ERROR_SUCCESS Then
      RegCloseKey keyHandle
      ErrRaise ret
    End If
    
    outArr(ValueNum).Name = Left$(outArr(ValueNum).Name, valueNumLength)
    valueNumLength = valueNumLength + 1
    
    Select Case outArr(ValueNum).ValueType
    Case REG_SZ
      strBuf = Space$(keyDataLength)
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, ByVal strBuf, keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = Left$(strBuf, keyDataLength - 1)
    Case REG_MULTI_SZ
      strBuf = Space$(keyDataLength)
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, ByVal strBuf, keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = Split(Left$(strBuf, keyDataLength - 2), vbNullChar)
    Case REG_EXPAND_SZ
      strBuf = Space$(keyDataLength)
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, ByVal strBuf, keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = ExpandString(Left$(strBuf, keyDataLength - 1))
    Case REG_DWORD
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, dwdBuf, keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = dwdBuf
    Case REG_BINARY
      ReDim binBuf(1 To keyDataLength)
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, binBuf(1), keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = binBuf
    Case REG_QWORD
      ret = RegEnumValue(keyHandle, ValueNum, outArr(ValueNum).Name, valueNumLength, 0&, ByVal 0&, qwdBuf, keyDataLength)
      If ret <> ERROR_SUCCESS Then
        RegCloseKey keyHandle
        ErrRaise ret
      End If
      outArr(ValueNum).Value = qwdBuf * 10000@
    Case Else
      RegCloseKey keyHandle
      Err.Raise 5, MyName, "Unsupported key type"
    End Select
  Next
  
  RegCloseKey keyHandle
  SubValues = outArr
End Function

Public Function ValueType(ByVal Root As RegRoots, RegPath As String, Optional ValueName As String = vbNullString) As RegDataTypes
  Dim ret As Long, keyHandle As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_QUERY_VALUE, keyHandle)
  If ret <> ERROR_SUCCESS Then ErrRaise ret
  
  ret = RegQueryValueEx(keyHandle, ValueName, 0, ValueType, ByVal 0&, ByVal 0&)
  RegCloseKey keyHandle
  If Len(ValueName) = 0 And ret = ERROR_FILE_NOT_FOUND Then ValueType = REG_NONE: Exit Function
  If ret <> ERROR_SUCCESS Then ErrRaise ret
End Function

Public Function SaveToFile(ByVal Root As RegRoots, RegPath As String, SaveTo As String) As Boolean
  '   -  .   ,
  '     ,   .
  '        REG.
  '     INI ,    
  'INI - 64 
  
  If Len(SaveTo) = 0 Then Exit Function
  fileHandle = FreeFile
  Open SaveTo For Output Access Write As #fileHandle
  Print #fileHandle, "REGEDIT4"; vbNewLine; vbNewLine
    
  SaveBranch Root, RegPath
  
  Close #fileHandle
  fileHandle = 0
  SaveToFile = True
End Function

Private Sub SaveBranch(ByVal Root As RegRoots, RegPath As String)
  '    .
  
  Dim keyHandle As Long
  Dim keyNum As Long, KeyType As RegDataTypes, tmpLong As Long, tmpStr As String
  Dim KeyName As String, keyNameLength As Long
  Dim keyData() As Byte, keyDataLength As Long
  
  '  ,   err.raise,   
  ' keyHandle     .
  '    ,        .
  
  If RegOpenKeyEx(Root, RegPath, 0, KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS, keyHandle) = ERROR_SUCCESS Then
    '  
    Print #fileHandle, "[" & RootName(Root) & IIf(Len(RegPath) = 0, vbNullString, "\" & RegPath) & "]"
    
    '   
    Do
      keyNameLength = 255
      KeyName = Space$(keyNameLength)
      
      Select Case RegEnumValue(keyHandle, keyNum, KeyName, keyNameLength, 0, KeyType, ByVal 0&, keyDataLength)
      Case ERROR_SUCCESS
        keyNameLength = keyNameLength + 1
        If KeyType = REG_DWORD Then
          If RegEnumValue(keyHandle, keyNum, KeyName, keyNameLength, 0, ByVal 0&, tmpLong, 4) = ERROR_SUCCESS Then
            tmpStr = LCase$(Hex$(tmpLong))
            tmpStr = String$(8 - Len(tmpStr), "0") & tmpStr
            If keyNameLength = 0 Then
              Print #fileHandle, "@=dword:" & tmpStr
            Else
              Print #fileHandle, """" & Left$(KeyName, keyNameLength) & """=dword:" & tmpStr
            End If
          End If
        Else
          If keyDataLength Then
            ReDim keyData(1 To keyDataLength)
            If RegEnumValue(keyHandle, keyNum, KeyName, keyNameLength, 0, ByVal 0&, keyData(LBound(keyData)), keyDataLength) = ERROR_SUCCESS Then
              If keyNameLength = 0 Then
                KeyName = "@"
              Else
                KeyName = """" & Left$(KeyName, keyNameLength) & """"
              End If
              If KeyType = REG_SZ Then
                tmpStr = StrConv(keyData, vbUnicode)
                If Len(tmpStr) Then tmpStr = Left$(tmpStr, Len(tmpStr) - 1)
                Print #fileHandle, KeyName & "=""" & Replace(tmpStr, "\", "\\") & """"
              Else
                Print #fileHandle, KeyName & "=hex" & IIf(KeyType = REG_BINARY, vbNullString, "(" & LCase$(Hex$(KeyType)) & ")") & ":" & Hex2String(keyData)
              End If
            End If
          Else
            Print #fileHandle, """" & Left$(KeyName, keyNameLength) & """="""""
          End If
        End If
      Case ERROR_NO_MORE_ITEMS
        Exit Do
      End Select
      keyNum = keyNum + 1
    Loop
    ' ,   ...
    Print #fileHandle,
    
    '      
    keyNum = 0
    Do
      keyNameLength = 255
      KeyName = Space$(keyNameLength)
      Select Case RegEnumKeyEx(keyHandle, keyNum, KeyName, keyNameLength, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&)
      Case ERROR_SUCCESS
        KeyName = Left$(KeyName, keyNameLength)
        SaveBranch Root, RegPath & IIf(Len(RegPath) = 0, vbNullString, "\") & KeyName
        keyNum = keyNum + 1
      Case ERROR_NO_MORE_ITEMS
        Exit Do
      End Select
    Loop
    RegCloseKey keyHandle
  End If
End Sub

Public Function LoadFromFile(FileName As String, Optional ByVal Silent As Boolean = False) As Boolean
  'Silent = False           
  'Silent = True              ,    
  
  Dim fileHandle As Integer, tmpStr As String
  Dim ValueName As String, ValueValue As String, b() As Byte
  Dim keyHandle As Long, ret As Long, LT As RegFileLineTypes
  
  fileHandle = FreeFile
  Open FileName For Input As #fileHandle
  
  '     "REGEDIT4"
  Line Input #fileHandle, tmpStr
  If tmpStr <> "REGEDIT4" Then
    Close #fileHandle
    If Not Silent Then Err.Raise 321, MyName Else Exit Function
  End If
  
  Do Until EOF(fileHandle)  '
    Line Input #fileHandle, tmpStr
    If Len(tmpStr) Then  '  
      LT = LineType(tmpStr, fileHandle, ValueName, ValueValue, b)
      Select Case LT
      Case lineKey   '   
        If keyHandle Then RegCloseKey keyHandle
        ret = RegCreateKeyEx(ValueValue, ValueName, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE Or KEY_CREATE_SUB_KEY, ByVal 0&, keyHandle, ByVal 0&)
        If ret <> ERROR_SUCCESS Then
          If Not Silent Then Close #fileHandle: ErrRaise ret
        End If
      Case lineDWord
        If keyHandle Then
          ret = RegSetValueEx(keyHandle, ValueName, 0, REG_DWORD, CLng("&h" & ValueValue), 4)
          If ret <> ERROR_SUCCESS Then
            If Not Silent Then RegCloseKey keyHandle: Close #fileHandle: ErrRaise ret
          End If
        Else
          If Not Silent Then Close #fileHandle: Err.Raise 321, MyName, "REG file contains Value entry without Key entry"
        End If
      Case lineString
        If keyHandle Then
          ret = RegSetValueEx(keyHandle, ValueName, 0, REG_SZ, ByVal ValueValue, Len(ValueValue))
          If ret <> ERROR_SUCCESS Then
            If Not Silent Then RegCloseKey keyHandle: Close #fileHandle: ErrRaise ret
          End If
        Else
          If Not Silent Then Close #fileHandle: Err.Raise 321, MyName, "REG file contains Value entry without Key entry"
        End If
      Case lineExpandedString, lineMultiString, lineHex, lineQWord
        If keyHandle Then
          On Error GoTo BlankArr
          ret = RegSetValueEx(keyHandle, ValueName, 0, LT, b(LBound(b)), VarPtr(b(UBound(b))) - VarPtr(b(LBound(b))) + 1)
          On Error GoTo 0
          If ret <> ERROR_SUCCESS Then
            If Not Silent Then RegCloseKey keyHandle: Close #fileHandle: ErrRaise ret
          End If
        Else
          If Not Silent Then Close #fileHandle: Err.Raise 321, MyName, "REG file contains Value entry without Key entry"
        End If
      Case lineInvalid
        If Not Silent Then RegCloseKey keyHandle: Close #fileHandle: Err.Raise 321, MyName
      End Select
    End If
  Loop
  
  RegCloseKey keyHandle
  Close #fileHandle
  LoadFromFile = True
  Exit Function
BlankArr:
  ret = RegSetValueEx(keyHandle, ValueName, 0, LT, ByVal 0&, 0)
  Resume Next
End Function

Private Function LineType(L As String, ByVal fileHandle As Integer, outName As String, outValue As String, b() As Byte) As RegFileLineTypes
  On Local Error GoTo errh
  Dim tmpLng As Long, tmpStr As String
  Dim Equal As Long, Colon As Long
  Dim tmpHex As String, Warp As Boolean
  Dim binArrPos As Long
  
  Const binArraySizeIncrement = 256
  
  LineType = lineInvalid
  
  If Len(L) = 0 Then Exit Function
  
  L = Trim$(L)
  
  If Left$(L, 1) = "[" And Right$(L, 1) = "]" Then ',   ?
    tmpLng = InStr(L, "\")
    If tmpLng = 0 Then tmpLng = Len(L)  ' "\" .
                                        ', ,   ?
    
    tmpStr = Mid$(L, 2, tmpLng - 2) '    .
                                    '   
    
    If RootValue(tmpStr) <> 0 Then
      ',    -  
      ' :       outName
      '    ,   outValue 
      '  .
      outValue = RootValue(tmpStr)
      If tmpLng < Len(L) Then outName = Mid$(L, tmpLng + 1, Len(L) - tmpLng - 1) Else outName = vbNullString
    Else
      Exit Function
    End If
    
    If Mid$(L, Len(L) - 2, 1) <> "\" Then LineType = lineKey
    Exit Function
  End If
  
  '  ,  ,  L  
  Equal = InStr(L, "=")
  
  Select Case Equal
  Case 1, 3
    Exit Function
  Case 2
    If Left$(L, 1) <> "@" Then Exit Function
    outName = vbNullString
  Case Else
    '       ,   
    If Left$(L, 1) <> """" Or Mid$(L, Equal - 1, 1) <> """" Then Exit Function
    outName = Mid$(L, 2, Equal - 3)
  End Select
  
  ',   ?
  If Mid$(L, Equal + 1, 1) = """" And Right$(L, 1) = """" Then
    outValue = Replace(Mid$(L, Equal + 2, Len(L) - Equal - 2), "\\", "\")
    LineType = lineString
    Exit Function
  End If
  
  ',  .    
  Colon = InStr(Equal + 1, L, ":")
  If Colon = 0 Then Exit Function
  
  '    "=".      
  tmpStr = Mid$(L, Equal + 1, Colon - Equal - 1)
  Select Case tmpStr
  Case "dword"
    '    8 .    .
    tmpStr = Right$(L, 8)
    For tmpLng = 1 To 8
      If InStr(1, "0123456789abcdef", Mid$(tmpStr, tmpLng, 1), vbTextCompare) = 0 Then Exit Function
    Next
    outValue = tmpStr
    LineType = lineDWord
    Exit Function
  Case "hex", "hex(2)", "hex(7)", "hex(b)"
    If tmpStr = "hex" Then LineType = lineHex Else LineType = CLng("&h" & Mid$(tmpStr, 5, 1))
    '      , .   ":"
    If Colon = Len(L) Then Erase b: Exit Function
    '- - .
    
    '   -     
    '  .     "\",    .
    '  -      fileHandle
    tmpStr = Mid$(L, Colon + 1)
    ReDim b(1 To binArraySizeIncrement)
    Do
      Warp = Right$(tmpStr, 1) = "\"
      For tmpLng = 1 To IIf(Warp, Len(tmpStr) - 2, Len(tmpStr)) Step 3
        tmpHex = Mid$(tmpStr, tmpLng, 2)
        If InStr(1, "0123456789abcdef", Left$(tmpHex, 1), vbTextCompare) = 0 Or InStr(1, "0123456789abcdef", Right$(tmpHex, 1), vbTextCompare) = 0 Then LineType = lineInvalid: Exit Function
        binArrPos = binArrPos + 1
        '     redim ,   ...
        If binArrPos > UBound(b) Then ReDim Preserve b(1 To UBound(b) + binArraySizeIncrement)
        b(binArrPos) = CByte("&h" & tmpHex)
      Next
      If Warp Then
        Line Input #fileHandle, tmpStr
        tmpStr = Trim$(tmpStr)
      End If
    Loop While Warp
    ReDim Preserve b(1 To binArrPos)
  Case Else
    Exit Function
  End Select
  
  Exit Function
errh:
  LineType = lineInvalid
End Function

Public Function RootName(ByVal Root As RegRoots) As String
  Select Case Root
  Case HKEY_CLASSES_ROOT:     RootName = "HKEY_CLASSES_ROOT"
  Case HKEY_CURRENT_CONFIG:   RootName = "HKEY_CURRENT_CONFIG"
  Case HKEY_CURRENT_USER:     RootName = "HKEY_CURRENT_USER"
  Case HKEY_DYN_DATA:         RootName = "HKEY_DYN_DATA"
  Case HKEY_LOCAL_MACHINE:    RootName = "HKEY_LOCAL_MACHINE"
  Case HKEY_PERFORMANCE_DATA: RootName = "HKEY_PERFORMANCE_DATA"
  Case HKEY_USERS:            RootName = "HKEY_USERS"
  Case Else:                  RootName = vbNullString
  End Select
End Function

Public Function RootValue(Root As String) As RegRoots
  Select Case UCase$(Root)
  Case "HKEY_CLASSES_ROOT":     RootValue = HKEY_CLASSES_ROOT
  Case "HKEY_CURRENT_CONFIG":   RootValue = HKEY_CURRENT_CONFIG
  Case "HKEY_CURRENT_USER":     RootValue = HKEY_CURRENT_USER
  Case "HKEY_DYN_DATA":         RootValue = HKEY_DYN_DATA
  Case "HKEY_LOCAL_MACHINE":    RootValue = HKEY_LOCAL_MACHINE
  Case "HKEY_PERFORMANCE_DATA": RootValue = HKEY_PERFORMANCE_DATA
  Case "HKEY_USERS":            RootValue = HKEY_USERS
  Case Else:                    RootValue = 0
  End Select
End Function

Private Function Hex2String(hexBuf() As Byte) As String
  Dim i As Long
  
  For i = LBound(hexBuf) To UBound(hexBuf)
    Hex2String = Hex2String & Format$(Hex$(hexBuf(i)), "00") & ","
  Next
  
  '  
  Hex2String = Left$(Hex2String, Len(Hex2String) - 1)
End Function

Private Sub ErrRaise(ByVal ErrCode As Long)
  Dim t As String
  
  t = Space$(255)
  t = Left$(t, FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrCode, 0, t, Len(t), ByVal 0&))
  Err.Raise ErrCode, MyName, t
End Sub

Private Function ExpandString(str As String) As String
  Dim ret As Long
  
  Const InitialSize As Long = 1024
  
  ExpandString = Space$(InitialSize)
  
  ret = ExpandEnvironmentStrings(str, ExpandString, InitialSize)
  If ret > InitialSize Then
    ExpandString = Space$(ret)
    ret = ExpandEnvironmentStrings(str, ExpandString, ret)
  End If
  
  ExpandString = Left$(ExpandString, ret - 1)
End Function
